import three;
import math;
texpreamble("\usepackage{bm}");

bool intrinsic_axes = false;
currentprojection=perspective(3000,7000,4000); 

// Incident ray parameters 
real graze = 20;

// Scatter parameters
real theta = radians(20);
real phi = radians(30);

include init;


draw(Label("$\bm{\hat{i}}$",0), -i--O,Arrow);
draw(Label("$\bm{\hat{r}}$", 1), O--r,Arrow, align = N);
draw(Label("$\bm{\hat{q}}$", 1), O--q,Arrow);
draw( scale(0.15) * ( q -- (q + r) -- r) );

draw( Label("$\bm{\alpha}$"), 
      arc(O, -0.8 * v, -0.8 ang_rad * i, normal = u ),
      small_arcarrows
       );

draw( Label("$\bm{\alpha}$"), 
      arc(O, ang_rad * v, ang_rad * r, normal = -u),
      W+S,
      small_arcarrows
       );

draw( Label("$\bm{\alpha}$"), 
      arc(O, 0.7q, -0.7n),
      small_arcarrows
       );

triple sp = cos(phi) * r + sin(phi) * u;
triple s = cos(theta) * sp + sin(theta) * q;

draw( arc(O, -u, u, normal = unit(cross(sp,u))), 
      currentpen + dashed,
      small_arcarrows
    );

draw( arc(O, sp, q ), currentpen + dashed );

draw( Label("$\bm{\hat{s}_\phi}$", 1), O -- sp, Arrow );
draw( Label("$\bm{\phi}$"), arc(O, r, sp, CCW ), .8N+E, small_arcarrows );

draw( Label("$\bm{\hat{s}}$", 1), O -- s, Arrow );
draw( Label("$\bm{\theta}$"), arc(O, sp, s), 0.5N+0.5W, small_arcarrows );



include finish;
